using System;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.navigationView.SelectionChanged             += navigationView_SelectionChanged;
            this.settingsItemVisibleCheckBox.Click           += settingsItemVisibleCheckBox_Click;
            this.backButtonVisibleCheckBox.Click             += backButtonVisibleCheckBox_Click;
            this.backButtonEnabledCheckBox.Click             += backButtonEnabledCheckBox_Click;
            this.autoSuggestBoxVisibleCheckBox.Click         += autoSuggestBoxVisibleCheckBox_Click;
            this.alwaysShowHeaderCheckBox.Click              += alwaysShowHeaderCheckBox_Click;
            this.paneCustomContentVisibleCheckBox.Click      += paneCustomContentVisibleCheckBox_Click;
            this.paneFooterVisibleCheckBox.Click             += paneFooterVisibleCheckBox_Click;
            this.leftPanePositionRadioButton.Checked         += leftPanePositionRadioButton_Checked;
            this.topPanePositionRadioButton.Checked          += topPanePositionRadioButton_Checked;
            this.keyboardSelectionFollowsFocusCheckBox.Click += keyboardSelectionFollowsFocusCheckBox_Click;
            this.selectionSuppressedCheckBox.Click           += selectionSuppressedCheckBox_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ׺̼    óϱ - navigationView_SelectionChanged(sender, e)

        /// <summary>
        /// ׺̼    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void navigationView_SelectionChanged(NavigationView sender, NavigationViewSelectionChangedEventArgs e)
        {
            if(e.IsSettingsSelected)
            {
                this.contentFrame.Navigate(typeof(SampleSettingPage));
            }
            else
            {
                NavigationViewItem selectedItem = e.SelectedItem as NavigationViewItem;

                if(selectedItem != null)
                {
                    string selectedItemTag = selectedItem.Tag as string;

                    sender.Header = "Sample Page " + selectedItemTag.Substring(selectedItemTag.Length - 1);

                    string pageName = "TestProject." + selectedItemTag;

                    Type pageType = Type.GetType(pageName);

                    this.contentFrame.Navigate(pageType);
                }
            }
        }

        #endregion
        #region Settings item visible üũ ڽ Ŭ óϱ - settingsItemVisibleCheckBox_Click(sender, e)

        /// <summary>
        /// Settings item visible üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void settingsItemVisibleCheckBox_Click(object sender, RoutedEventArgs e)
        {
            this.navigationView.IsSettingsVisible = (sender as CheckBox).IsChecked == true ? true : false;
        }

        #endregion
        #region Back button visible üũ ڽ Ŭ óϱ - backButtonVisibleCheckBox_Click(sender, e)

        /// <summary>
        /// Back button visible üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void backButtonVisibleCheckBox_Click(object sender, RoutedEventArgs e)
        {
            if((sender as CheckBox).IsChecked == true)
            {
                this.navigationView.IsBackButtonVisible = NavigationViewBackButtonVisible.Visible;
            }
            else
            {
                this.navigationView.IsBackButtonVisible = NavigationViewBackButtonVisible.Collapsed;
            }
        }

        #endregion
        #region Back button enabled üũ ڽ Ŭ óϱ - backButtonEnabledCheckBox_Click(sender, e)

        /// <summary>
        /// Back button enabled üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void backButtonEnabledCheckBox_Click(object sender, RoutedEventArgs e)
        {
            this.navigationView.IsBackEnabled = (sender as CheckBox).IsChecked == true ? true : false;
        }

        #endregion
        #region AutoSuggestBox visible üũ ڽ Ŭ óϱ - autoSuggestBoxVisibleCheckBox_Click(sender, e)

        /// <summary>
        /// AutoSuggestBox visible üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void autoSuggestBoxVisibleCheckBox_Click(object sender, RoutedEventArgs e)
        {
            if((sender as CheckBox).IsChecked == true)
            {
                AutoSuggestBox autoSuggestBox = new AutoSuggestBox() { QueryIcon = new SymbolIcon(Symbol.Find) };

                this.navigationView.AutoSuggestBox = autoSuggestBox;
            }
            else
            {
                this.navigationView.AutoSuggestBox = null;
            }
        }

        #endregion
        #region Always show header üũ ڽ Ŭ óϱ - alwaysShowHeaderCheckBox_Click(sender, e)

        /// <summary>
        /// Always show header üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void alwaysShowHeaderCheckBox_Click(object sender, RoutedEventArgs e)
        {
            this.navigationView.AlwaysShowHeader = (sender as CheckBox).IsChecked == true ? true : false;
        }

        #endregion
        #region PaneCustomContent visible üũ ڽ Ŭ óϱ - paneCustomContentVisibleCheckBox_Click(sender, e)

        /// <summary>
        /// PaneCustomContent visible üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void paneCustomContentVisibleCheckBox_Click(object sender, RoutedEventArgs e)
        {
            if((sender as CheckBox).IsChecked == true)
            {
                this.paneHyperlinkButton.Visibility = Visibility.Visible;
            }
            else
            {
                this.paneHyperlinkButton.Visibility = Visibility.Collapsed;
            }
        }

        #endregion
        #region PaneFooter visible üũ ڽ Ŭ óϱ - paneFooterVisibleCheckBox_Click(sender, e)

        /// <summary>
        /// PaneFooter visible üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void paneFooterVisibleCheckBox_Click(object sender, RoutedEventArgs e)
        {
            if((sender as CheckBox).IsChecked == true)
            {
                this.footerStackPanel.Visibility = Visibility.Visible;
            }
            else
            {
                this.footerStackPanel.Visibility = Visibility.Collapsed;
            }
        }

        #endregion
        #region Left PanePosition  ư üũ óϱ - leftPanePositionRadioButton_Checked(sender, e)

        /// <summary>
        /// Left PanePosition  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void leftPanePositionRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if((sender as RadioButton).IsChecked == true)
            {
                this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Left;
                this.navigationView.IsPaneOpen      = true;

                this.footerStackPanel.Orientation = Orientation.Vertical;
            }
        }

        #endregion
        #region Top PanePosition  ư üũ óϱ - topPanePositionRadioButton_Checked(sender, e)

        /// <summary>
        /// Top PanePosition  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void topPanePositionRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if((sender as RadioButton).IsChecked == true)
            {
                this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Top;
                this.navigationView.IsPaneOpen      = false;

                this.footerStackPanel.Orientation = Orientation.Horizontal;
            }
        }

        #endregion
        #region Keyboard SelectionFollowsFocus üũ ڽ Ŭ óϱ - keyboardSelectionFollowsFocusCheckBox_Click(sender, e)

        /// <summary>
        /// Keyboard SelectionFollowsFocus üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void keyboardSelectionFollowsFocusCheckBox_Click(object sender, RoutedEventArgs e)
        {
            if((sender as CheckBox).IsChecked == true)
            {
                this.navigationView.SelectionFollowsFocus = NavigationViewSelectionFollowsFocus.Enabled;
            }
            else
            {
                this.navigationView.SelectionFollowsFocus = NavigationViewSelectionFollowsFocus.Disabled;
            }
        }

        #endregion
        #region Selection of Menu Item2 suppressed üũ ڽ Ŭ óϱ - selectionSuppressedCheckBox_Click(sender, e)

        /// <summary>
        /// Selection of Menu Item2 suppressed üũ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void selectionSuppressedCheckBox_Click(object sender, RoutedEventArgs e)
        {
            this.navigationViewItem2.SelectsOnInvoked = (sender as CheckBox).IsChecked == true ? false : true;
        }

        #endregion
    }
}